#include <chrono>
#include <fstream>
#include <functional>
#include <iostream>

#include "matrice.h"

using namespace std;

/**
 * Fonction permettant de mesurer le temps d'exécution d'une fonction
 * passée en paramètre.
 *
 * Exemple d'utilisation:
 *  int temps = benchmark([&]() { maFonction(param1, param2);});
 *
 * @param f La fonction à mesurer
 * @return Le temps d'exécution en millisecondes
 */
int benchmark(function<void()> f) {
  const auto start = chrono::high_resolution_clock::now();
  f();
  const auto end = chrono::high_resolution_clock::now();
  return chrono::duration_cast<chrono::milliseconds>(end - start).count();
}

void evalEmpirique() {
  // Créer le flux de sortie pour le fichier csv
  ofstream ofs("data.csv");

  // Afficher l'en-tête du tableau


  // Tester le fichier correspondant à chaque taille de matrice (100, 200, ..., 1000)
  for (int i = 100; i <= 1000; i += 100) {
    ifstream ifs("testTaille_" + to_string(i) + ".mat");
    if (!ifs) {
      cerr << "Impossible d'ouvrir le fichier" << endl;
      exit(EXIT_FAILURE);
    }

    // Lecture des deux matrices dans le fichier


    // Calcul du temps d'exécution de chacune des méthodes


    // Écriture de la ligne courante du fichier csv des résultats

  }
}

int main() {
  evalEmpirique();
  return EXIT_SUCCESS;
}
