/**
 * Squelette de code d'une matrice générique
 * INF3105 - Structures de données et algorithmes
 * UQAM / Département d'informatique
 */
#ifndef __MATRICE_H__
#define __MATRICE_H__

#include <iostream>

#include "tableau.h"

template<class T>
class Matrice {
 public:
  // Constructeur
  Matrice(int lignes = 1, int colonnes = 1);

  Matrice<T> t() const;  // Transposition de la matrice
  void ajouterLigne(int position, const T& valeur = T());

  // Opérateurs d'accès ()
  T& operator()(int i, int j);
  const T& operator()(int i, int j) const;

  // Opérateurs
  bool operator==(const Matrice<T>& autre) const;
  bool operator!=(const Matrice<T>& autre) const;
  Matrice<T> operator+(const Matrice<T>& autre) const;
  Matrice<T> operator*(const Matrice<T>& autre) const;

  friend std::istream& operator>>(std::istream& is, Matrice<T>& matrice) {
    int lig, col;
    is >> lig >> col;
    matrice = Matrice<T>(lig, col);

    // À compléter


    return is;
  }

 private:
  // À compléter


  // Pour permettre aux tests d'accéder aux méthodes privées à comparer
  friend void evalEmpirique(); // Ne pas enlever.
};

#endif
