/*  Tests unitaires pour Matrice<T>.
 *  TP1 -- Tableau dynamique générique
 *  INF3105 | Structures de données et algorithmes
 *  UQAM | Département d'informatique
 */

#include <fstream>
#include <iostream>

#include "matrice.h"

using namespace std;

bool test1() {
  cout << "test1() : additions" << endl;

  ifstream ifs("test1.mat");
  if (!ifs) {
    cout << "Erreur ouverture fichier test1.mat" << endl;
    return false;
  }

  Matrice<int> m1, m2, m3;
  ifs >> m1 >> m2 >> m3;

  if (m1 + m2 != m3) {
    cout << " ==> ECHEC m1+m2!=m3" << endl;
    return false;
  }

  cout << " ==> OK" << endl;
  return true;
}

bool test2() {
  cout << "test2() : produit" << endl;

  ifstream ifs("test2.mat");
  if (!ifs) {
    cout << "Erreur ouverture fichier test1.mat" << endl;
    return false;
  }

  Matrice<int> m1, m2, m3;
  ifs >> m1 >> m2 >> m3;

  if (m1 * m2 != m3) {
    cout << " ==> ECHEC m1*m2!=m3" << endl;
    return false;
  }

  cout << " ==> OK" << endl;
  return true;
}

bool test3() {
  cout << "test3() : transposition" << endl;

  ifstream ifs("test3.mat");
  if (!ifs) {
    cout << "Erreur ouverture fichier test3.mat" << endl;
    return false;
  }

  Matrice<int> m1, m2;
  ifs >> m1 >> m2;

  if(m1.t().t() != m1) {
    cout << " ==> ECHEC m1.tr().tr()!=m1" << endl;
    return false;
  }

  if (m1.t() != m2) {
    cout << " ==> ECHEC m1.tr()!=m2" << endl;
    return false;
  }

  cout << " ==> OK" << endl;
  return true;
}

bool test4() {
  cout << "test4() : ajout de ligne" << endl;

  ifstream ifs("test4.mat");
  if (!ifs) {
    cout << "Erreur ouverture fichier test4.mat" << endl;
    return false;
  }

  Matrice<int> m1, m2;
  ifs >> m1 >> m2;

  m1.ajouterLigne(1);

  if (m1 != m2) {
    cout << " ==> ECHEC m1!=m2" << endl;
    return false;
  }

  cout << " ==> OK" << endl;
  return true;
}

int main() {
  bool testsreussis = true  // Cette ligne «true» a été insérée pour faciliter la
                            // mise en commentaire de la ligne suivante.
                      && test1()
                      && test2()
                      && test3()
                      && test4()
                      ;

  cout << "**** Sommaire ****\n";

  if (testsreussis) {
    cout << "=> BRAVO, tous les tests de cette partie du TP1 ont été réussis!\n"
              << "=> Attention, ces tests ne sont pas exhaustifs.\n"
              << "=> Réussir tous ces tests ne garanti l'absence de failles.\n"
              << "=> Soyez vigilants, il pourrait rester des bogues." << endl;
  } else {
    cout << "=> DÉSOLÉ, au moins un test a échoué.\n";
    cout << "=> Ne lâchez pas!" << endl;
  }
  return testsreussis ? 0 : 1;
}
