/*  Tests unitaires pour Tableau<T>.
 *  Lab3 -- Tableau dynamique générique
 *  INF3105 | Structures de données et algorithmes
 *  UQAM | Département d'informatique
 */

#include <iostream>

#include "tableau.h"

using namespace std;

bool test1() {
  cout << "test1() : ajouts simples" << endl;
  Tableau<int> t;
  t.ajouter(3);
  t.ajouter(4);
  bool reussi = true;
  if (t[0] != 3) {
    cout << " ==> ECHEC t[0]!=3" << endl;
    reussi = false;
  }
  if (t[1] != 4) {
    cout << " ==> ECHEC t[1]!=4" << endl;
    reussi = false;
  }
  if (t.taille() != 2) {
    cout << " ==> ECHEC Taille" << endl;
    reussi = false;
  }
  if (reussi) cout << " ==> OK" << endl;
  return reussi;
}

bool test2() {
  cout << "test2() : ajouts +" << endl;
  bool reussi = true;
  Tableau<int> t;
  int n = 256 * 256;
  for (int i = 0; i < n; i++) t.ajouter(i * 2);

  if (t.taille() != n) {
    cout << " ==> ECHEC taille()" << endl;
    reussi = false;
  }

  for (int i = 0; i < t.taille(); i++)
    if (t[i] != i * 2) {
      cout << " ==> ECHEC : t[i]=" << t[i] << "!=" << (i * 2) << endl;
      reussi = false;
    }
  if (reussi) cout << " ==> OK" << endl;
  return reussi;
}

bool test3() {
  cout << "test3() : operator =" << endl;
  Tableau<int> t1;
  for (int i = 0; i < 10; i++) t1.ajouter(i);
  Tableau<int> t2;
  t2 = t1;

  if (t2.taille() != 10) {
    cout << " ==> ECHEC taille()" << endl;
    return false;
  }

  for (int i = 0; i < 10; i++)
    if (t2[i] != i) {
      cout << " ==> ECHEC : t2[i]=" << t2[i] << "!=" << (i) << endl;
      return false;
    }

  cout << " ==> OK" << endl;
  return true;
}

bool test4() {
  cout << "test4() : operator =" << endl;
  Tableau<int> t1;
  for (int i = 0; i < 10; i++) t1.ajouter(i);
  Tableau<int> t2;
  t2 = t1;

  for (int i = 0; i < 10; i++) t1[i] = 0;
  t1.ajouter(0);

  if (t2.taille() != 10) {
    cout << " ==> ECHEC taille()" << endl;
    return false;
  }

  for (int i = 0; i < 10; i++)
    if (t2[i] != i) {
      cout << " ==> ECHEC : t2[i]=" << t2[i] << "!=" << (i) << endl;
      return false;
    }

  cout << " ==> OK" << endl;
  return true;
}

bool test5() {
  cout << "test5() : operator =" << endl;
  Tableau<int> t1;
  for (int i = 0; i < 10; i++) t1.ajouter(i);
  Tableau<int> t2;
  t2 = t1;
  t1.vider();
  for (int i = 0; i < 100; i++) t1.ajouter(i + 1);
  t2 = t1;

  if (t2.taille() != 100) {
    cout << " ==> ECHEC t2.taille()" << endl;
    return false;
  }

  for (int i = 0; i < t2.taille(); i++)
    if (t2[i] != i + 1) {
      cout << " ==> ECHEC : t2[i]=" << t2[i] << "!=" << (i + 1)
                << endl;
      return false;
    }

  Tableau<int> t3;
  for (int i = 0; i < 100; i++) t3.ajouter(i);
  Tableau<int> t4;
  t4 = t3;
  t3.vider();
  for (int i = 0; i < 10; i++) t3.ajouter(i + 1);
  t4 = t3;

  if (t4.taille() != 10) {
    cout << " ==> ECHEC t4.taille()" << endl;
    return false;
  }

  for (int i = 0; i < t4.taille(); i++)
    if (t4[i] != i + 1) {
      cout << " ==> ECHEC : t4[i]=" << t4[i] << "!=" << (i + 1)
                << endl;
      return false;
    }

  cout << " ==> OK" << endl;
  return true;
}

bool test6() {
  cout << "test6() : operator =" << endl;
  Tableau<int> t1, t2;
  for (int i = 0; i < 100; i++) t1.ajouter(i);
  t1 = t1;  // devrait être sans effet.
  if (t1.taille() != 100) {
    cout << " ==> ECHEC taille()" << endl;
    return false;
  }

  for (int i = 0; i < 100; i++)
    if (t1[i] != i) {
      cout << " ==> ECHEC : t1[i]=" << t1[i] << "!=" << (i) << endl;
      return false;
    }

  cout << " ==> OK" << endl;
  return true;
}

bool test7() {
  cout << "test7() : constructeur par copie" << endl;
  Tableau<int> t1;
  for (int i = 0; i < 10; i++) t1.ajouter(i);
  Tableau<int> t2(t1);

  if (t2.taille() != 10) {
    cout << " ==> ECHEC taille()" << endl;
    return false;
  }

  for (int i = 0; i < t2.taille(); i++)
    if (t2[i] != i) {
      cout << " ==> ECHEC : t2[i]=" << t2[i] << "!=" << i << endl;
      return false;
    }

  cout << " ==> OK" << endl;
  return true;
}

bool test8() {
  cout << "test8() : operator ==" << endl;
  Tableau<int> t1;
  Tableau<int> t2;
  for (int i = 0; i < 1024; i++) {
    t1.ajouter(i);
    t2.ajouter(i);
  }

  t1.ajouter(3);
  bool ok = true;

  if (t1 == t2) {
    cout << " ==> ECHEC #1" << endl;
    ok = false;
  }
  if (t2 == t1) {
    cout << " ==> ECHEC #2" << endl;
    ok = false;
  }
  t2.ajouter(3);
  if (!(t1 == t2)) {
    cout << " ==> ECHEC #3" << endl;
    ok = false;
  }
  if (!(t2 == t1)) {
    cout << " ==> ECHEC #4" << endl;
    ok = false;
  }

  if (!(t1 == t1)) {
    cout << " ==> ECHEC #5" << endl;
    ok = false;
  }

  Tableau<int> t3;
  if (t1 == t3) {
    cout << " ==> ECHEC #6" << endl;
    ok = false;
  }
  t3 = t2;
  if (!(t1 == t3)) {
    cout << " ==> ECHEC #6" << endl;
    ok = false;
  }

  if (ok) cout << " ==> OK" << endl;
  return ok;
}

bool test9() {
  cout << "test9() : insertion" << endl;
  Tableau<int> t1;
  Tableau<int> t2;
  for (int i = 0; i < 16; i++) {
    t1.ajouter(i + 1);
    t2.ajouter(i);
  }

  t1.inserer(0);
  t2.ajouter(16);

  bool ok = true;
  if (!(t1 == t2)) {
    cout << " ==> ECHEC #1" << endl;
    ok = false;
  }

  Tableau<int> t3;
  for (int i = 4; i < 17; i++) {
    t3.ajouter(i);
  }
  t3.inserer(1, 0);
  t3.inserer(0, 0);
  t3.inserer(3, 2);
  t3.inserer(2, 2);

  if (!(t1 == t2)) {
    cout << " ==> ECHEC #2" << endl;
    ok = false;
  }
  if (ok) cout << " ==> OK" << endl;
  return ok;
}

bool test10() {
  cout << "test10() : enlèvement" << endl;
  Tableau<int> t1;
  for (int i = 0; i < 16; i++) {
    t1.ajouter(i);
  }

  t1.enlever(5);
  Tableau<int> t2;
  for (int i = 0; i < 5; i++) {
    t2.ajouter(i);
  }
  for (int i = 6; i < 16; i++) {
    t2.ajouter(i);
  }

  bool ok = true;
  if (!(t1 == t2)) {
    cout << " ==> ECHEC #1" << endl;
    ok = false;
  }

  t1.enlever_dernier();
  t2.enlever_dernier();
  if (!(t1 == t2)) {
    cout << " ==> ECHEC #2" << endl;
    ok = false;
  }

  if (ok) cout << " ==> OK" << endl;
  return ok;
}

bool test11() {
  cout << "test11() : chercher" << endl;
  Tableau<int> t1;
  for (int i = 0; i < 100; i++) {
    t1.ajouter(i * 2);
  }

  bool ok = true;

  for (int i = 0; i < 100; i++) {
    int index = t1.chercher(i * 2);
    bool estPresent = t1.contient(i * 2);
    if (index != i || !estPresent) {
      cout << " ==> ECHEC i=" << i << endl;
      ok = false;
      break;
    }

    index = t1.chercher(i * 2 + 1);
    estPresent = t1.contient(i * 2 + 1);
    if (index != -1 || estPresent) {
      cout << " ==> ECHEC i=" << i << endl;
      ok = false;
      break;
    }
  }
  if (ok) cout << " ==> OK" << endl;
  return ok;
}

class Point {
 public:
  Point(double x_ = 0, double y_ = 0) : x(x_), y(y_) {}
  bool operator==(const Point& autre) const {
    return x == autre.x && y == autre.y;
  }

 private:
  double x, y;
};

bool test12() {
  cout << "test12() : chercher" << endl;
  Tableau<Point> points;
  points.ajouter(Point());
  points.ajouter(Point(2, 3));
  points.ajouter(Point(4, 5));
  points.ajouter(Point(3, 4));
  Tableau<Point> points2;
  points2 = points;
  int index = points.chercher(Point(4, 5));
  bool ok = index == 2;
  if (ok)
    cout << " ==> OK" << endl;
  else
    cout << " ==> ECHEC" << endl;
  return ok;
}

int main() {
  bool testsreussis = true  // Cette ligne «true» a été insérée pour faciliter la
                            // mise en commentaire de la ligne suivante.
                      && test1() && test2() && test3() && test4() && test5()
                      && test6() && test7() && test8() && test9() && test10()
                      && test11() && test12()
                      ;

  cout << "**** Sommaire ****\n";

  if (testsreussis) {
    cout << "=> BRAVO, tous les tests de cette partie du TP1 ont été réussis!\n"
              << "=> Attention, ces tests ne sont pas exhaustifs.\n"
              << "=> Réussir tous ces tests ne garanti l'absence de failles.\n"
              << "=> Soyez vigilants, il pourrait rester des bogues." << endl;
  } else {
    cout << "=> DÉSOLÉ, au moins un test a échoué.\n";
    cout << "=> Ne lâchez pas!" << endl;
  }
  return testsreussis ? 0 : 1;
}
